package hashing;

public class OpenAddressingSimpleHashtable<T> implements SimpleHashtable<T> {

	private T[] dataTable;
	private int count;
	private int probingStrategy; 
	
	public OpenAddressingSimpleHashtable(int tablesize, int p){
		dataTable = (T[])  (new Object[tablesize]);
		for(int i=0; i<tablesize; i++)
			dataTable[i]=null;
		count=0;
		
		probingStrategy = p;
	}
	
	
	private int probe(int h, int i){
		if(probingStrategy==0) // linear probing
		  return (h+i)%dataTable.length;
		else // quadratic probing
			return (h+i*i)%dataTable.length;
	}
	
	@Override
	public void add(T key) {
		// Maybe need to increase capacity of dataTable?
		
		
		int h = key.hashCode()%dataTable.length;
		int i=1;
		int current = h;
		while(dataTable[current]!=null){
		  current = probe(h,i);
		  i++;
		}
		dataTable[current] = key;
		count++;
	} // add

		

	@Override
	public boolean find(T key) {
		// TODO Auto-generated method stub
		
		int h = key.hashCode()%dataTable.length;
		int i=1;
		int current = h;
		while(dataTable[current]!=null && !dataTable[current].equals(key)){
		  current = probe(h,i);
		  i++;
		}
		
		return (dataTable[current]!=null); //true if non-null
	}

	@Override
	public boolean remove(T key) {
		// TODO Auto-generated method stub
		return false;
	}
	
	public String toString(){
		String result="Hashtable storing "+count+" elements in a table of size "+dataTable.length;
		for(int i=0; i<dataTable.length; i++){
			result+="\n"+i+": "+dataTable[i];
		}
		return result;
	}

	
}
